%%% news_check_likelihoods.m --- 
%% 
%% Description: Compares the likelihoods generated by fortran program, SGU
%%   code, and our matlab code.
%% 
%% Author: Ed Herbst [edward.p.herbst@frb.gov]
%% Last-Updated: 08/03/12
%% 

phistr = '260';
base = '/mq/scratch/m1eph00/smc-news-diffuse-mu-mix-npart-30048-nintmh-1-nphi-500-prior-b6-trial1-phibend/';

ncheck = 20;


parafile = strcat(base, phistr, 'parasim.txt');
likfile = strcat(base, phistr, 'liksim.txt');

para1 = load(parafile);
lik1 = load(likfile);

nsim = size(para1, 1);

load read_data

for j = 1:ncheck;
    i = randi(nsim);
    p0 = para1(i, :)';
    
    [nfx, nfy, nfxp, nfyp, nvarshock, nvarme, nETASHOCK ] = gx_hx_inputs(eph2sgu_para(p0));
    [gx,hx,exitflag]=gx_hx(nfy,nfx,nfyp,nfxp);

    if (size(gx, 1) == 1)
        sgu_lik = -1000.00;
    else
        GX = [gx(1:6 ,:); emua];
        sgu_lik = log_like_kalman(Y, hx, nvarshock, GX', nvarme);
    end 
    YY = [Y(:, 1:5) Y(:, 7) Y(:, 6)] + DDmat;
    matlab_lik = objfun_cr(YY, p0, 0);

    fprintf('%5i  %-7.2f  %-7.2f  %-7.2f \n', [i sgu_lik matlab_lik lik1(i)])
    

end


priorfile1 = '/mq/home/m1eph00/projects/dsge-smc/code/models/news/prior.txt';
priorfile2 = '/mq/home/m1eph00/projects/dsge-smc/code/models/news/diffuse_prior.txt';

prior1 = load(priorfile1);
prior2 = load(priorfile2);


g1 = @(x) priodens(x, prior1(:, 2), prior1(:, 3), prior1(:, 1));
g2 = @(x) priodens(x, prior2(:, 2), prior2(:, 3), prior2(:, 1));


